// ColList.cpp
//
// FtXg{bNX

#include "stdafx.h"
#include "ColList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColList

CColList::CColList()
{
	m_nSelectIndex=-1;
	m_nTopLine=0;
	m_bRedraw=TRUE;
	m_bOnCapture=FALSE;
	m_nDrawInsertPointerIndex=-1;
	m_bDrawInsertPointer=FALSE;
	m_nIdTimer=0;
}

CColList::~CColList()
{
	POSITION pos=m_listData.GetHeadPosition();
	while(pos){
		CColListData* pData=m_listData.GetNext(pos);
		delete pData;
	}
	m_listData.RemoveAll();
}


BEGIN_MESSAGE_MAP(CColList, CWnd)
	//{{AFX_MSG_MAP(CColList)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_VSCROLL()
	ON_WM_SETFOCUS()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KILLFOCUS()
	ON_WM_TIMER()
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//eEChECLN_SELCHANGE𑗂
void CColList::PostSelChange()
{
	int nID=GetDlgCtrlID();
	CWnd* pWnd=GetParent();
	if(pWnd) pWnd->PostMessage(WM_COMMAND,
		MAKELONG(nID,CLN_SELCHANGE),(LPARAM)m_hWnd);
}

//eEChECLN_MOVEITEM𑗂
void CColList::PostMoveItem()
{
	int nID=GetDlgCtrlID();
	CWnd* pWnd=GetParent();
	if(pWnd) pWnd->PostMessage(WM_COMMAND,
		MAKELONG(nID,CLN_MOVEITEM),(LPARAM)m_hWnd);
}



//WM_SIZE𑗂
void CColList::Resize()
{
	CRect rc;
	SendMessage(WM_SIZE,0,MAKELONG(m_sizeClient.cx,m_sizeClient.cy));
}

//ĕ`̋^֎~
void CColList::SetAutoRedraw(BOOL bRedraw)
{
	m_bRedraw=bRedraw;
	if(m_bRedraw)Resize();
}

//hbȎ}|C^̕`
void CColList::DrawInsertPointer(BOOL bDraw,CDC* pDC)
{
	if(!bDraw && !m_bDrawInsertPointer) return;

	m_bDrawInsertPointer=bDraw;

	BOOL bUseLocalDC=FALSE;
	if(m_nDrawInsertPointerIndex < m_nTopLine || 
	   m_nDrawInsertPointerIndex >= (m_nTopLine+m_nLine) ) return;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
	}
	CPoint points,pointe;
	points.y=pointe.y=(m_nDrawInsertPointerIndex-m_nTopLine)*m_nLineHeight;
	points.x=0;
	pointe.x=m_sizeClient.cx;
	
	COLORREF colLine=GetSysColor(COLOR_HIGHLIGHT);
	CPen pen(PS_DOT,1,colLine);
	CPen* pPen=pDC->SelectObject(&pen);
	int nOldROP2=pDC->SetROP2(R2_NOT);
	int nOldBkMode=pDC->SetBkMode(TRANSPARENT);
	pDC->MoveTo(points);
	pDC->LineTo(pointe);
	pDC->SetBkMode(nOldBkMode);
	pDC->SetROP2(nOldROP2);
	pDC->SelectObject(pPen);

	if(bUseLocalDC)delete pDC;
}



//ws`
void CColList::DrawLine(int nIndex,CDC* pDC)
{
	BOOL bUseLocalDC=FALSE;
	if(nIndex < m_nTopLine || nIndex>= (m_nTopLine+m_nLine) ) return;
	if(nIndex>=m_listData.GetCount()){
		return;
	}
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
	}
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return;
	}
	CColListData* pData=m_listData.GetAt(pos);
	int y=(nIndex-m_nTopLine)*m_nLineHeight;
	
	COLORREF colNewBk,colNewText,colOldText,colPen;
	int	nOldBkMode;
	if(nIndex==m_nSelectIndex)
	{//IԂ̐Fݒ
		if(GetFocus()==this)
		{
			colNewBk	=(COLORREF)GetSysColor(COLOR_HIGHLIGHT);
			colNewText	=(COLORREF)GetSysColor(COLOR_HIGHLIGHTTEXT);
			colPen		=colNewBk;
		}
		else
		{
			colNewBk	=(COLORREF)GetSysColor(COLOR_WINDOW);
			colNewText	=(COLORREF)GetSysColor(COLOR_HIGHLIGHT);
			colPen		=colNewText;
		}
	}
	else
	{//IԂ̐Fݒ͊evfm_coloro[ɏ]
		colNewBk	=(COLORREF)GetSysColor(COLOR_WINDOW);
		colNewText	=pData->m_color;
		colPen		=colNewBk;
	}
	nOldBkMode=pDC->SetBkMode(TRANSPARENT);
	colOldText=pDC->SetTextColor(colNewText);
	CBrush  brush(colNewBk);
	CPen	pen(PS_SOLID,1,colPen);
	CBrush* pOldBrush=pDC->SelectObject(&brush);
	CPen*   pOldPen  =(CPen*)pDC->SelectObject(&pen);
	pDC->Rectangle(0,y,m_sizeClient.cx,m_nLineHeight+y);
	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);
	pDC->TextOut(0,y,pData->m_str);
	pDC->SetTextColor(colOldText);
	pDC->SetBkMode(nOldBkMode);

	if(bUseLocalDC) delete pDC;
}


//ACẽZbg
BOOL CColList::SetItem(int nIndex,LPCSTR pStr,DWORD dw,COLORREF col)
{
	if(pStr==NULL) return FALSE;
	if(col==0x80000000)col=(COLORREF)GetSysColor(COLOR_WINDOWTEXT);
	CColListData* pData=new CColListData;
	pData->m_str	=CString(pStr);
	pData->m_dwData	=dw;
	pData->m_color	=col;
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0){
		m_listData.AddTail(pData);
	}else{
		POSITION pos=m_listData.FindIndex(nIndex);
		m_listData.InsertBefore(pos,pData);
	}

	if(m_nSelectIndex >= nIndex)
	{//I𒆂̃ACeႢꏊɃZbgꍇ
		m_nSelectIndex++;
	}
	if(m_bRedraw){
		Resize();
		Invalidate();
	}
	return TRUE;
}

//ACȅ
BOOL CColList::DeleteItem(int nIndex)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return FALSE;
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return FALSE;
	}

	CColListData* pData=m_listData.GetAt(pos);
	delete pData;
	m_listData.RemoveAt(pos);

	nCount--;
	if(m_nSelectIndex == nIndex)
	{//I𒆂̃ACeꍇ
		if(m_nSelectIndex>=nCount)
		{
			m_nSelectIndex--;
		}
		PostSelChange();
	}
	else if(m_nSelectIndex > nIndex)
	{//I𒆂̃ACeႢACeꍇ
		m_nSelectIndex--;
	}
	if(m_bRedraw) Resize();
	return TRUE;
}

void CColList::DeleteAll()
{
	m_nSelectIndex=-1;
	m_nTopLine=0;
	m_bRedraw=TRUE;
	m_bOnCapture=FALSE;
	m_nDrawInsertPointerIndex=-1;
	m_bDrawInsertPointer=FALSE;

	POSITION pos=m_listData.GetHeadPosition();
	while(pos){
		CColListData* pData=m_listData.GetNext(pos);
		delete pData;
	}
	m_listData.RemoveAll();
	Invalidate();
}



//񂾂̕ύX
BOOL CColList::ReplaceString(int nIndex,LPCSTR strNew)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return FALSE;
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return FALSE;
	}

	CColListData* pData=m_listData.GetAt(pos);
	pData->m_str=CString(strNew);
	if(m_bRedraw) DrawLine(nIndex);
	return TRUE;
}

//f[^̕ύX
BOOL CColList::ReplaceData(int nIndex,DWORD dwNew)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return FALSE;
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return FALSE;
	}

	CColListData* pData=m_listData.GetAt(pos);
	pData->m_dwData=dwNew;
	return TRUE;
}

//F̕ύX
BOOL CColList::SetColor(int nIndex,COLORREF colNew)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return FALSE;
	if(colNew==0x80000000)colNew=(COLORREF)GetSysColor(COLOR_WINDOWTEXT);
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return FALSE;
	}
	CColListData* pData=m_listData.GetAt(pos);
	if(pData->m_color!=colNew){
		pData->m_color=colNew;
		if(m_bRedraw) DrawLine(nIndex);
	}
	return TRUE;
}

//̎擾
CString CColList::GetString(int nIndex)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return CString("");
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return CString("");
	}

	CColListData* pData=m_listData.GetAt(pos);
	return pData->m_str;
}

//f[^̎擾
DWORD CColList::GetData(int nIndex)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return 0;
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return 0;
	}

	CColListData* pData=m_listData.GetAt(pos);
	return pData->m_dwData;
}

//F̎擾
COLORREF CColList::GetColor(int nIndex)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex || nIndex<0) return 0;
	POSITION pos=m_listData.FindIndex(nIndex);
	if(!pos){
		return 0;
	}

	CColListData* pData=m_listData.GetAt(pos);
	return pData->m_color;
}


//IԂ̐ݒ
BOOL CColList::SetSel(int nIndex)
{
	int nCount=m_listData.GetCount();
	if(nCount<=nIndex)return FALSE;
	int nOldSel=m_nSelectIndex;
	m_nSelectIndex=nIndex;
	if(nOldSel>=0)			DrawLine(nOldSel);
	if(m_nSelectIndex>=0)	DrawLine(m_nSelectIndex);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CColList bZ[W nh

void CColList::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg

	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	int ntop,nbottom;
	ntop	=dc.m_ps.rcPaint.top						/m_nLineHeight;
	ntop+=m_nTopLine;
	nbottom	=(dc.m_ps.rcPaint.bottom+(m_nLineHeight-1))	/m_nLineHeight;
	nbottom+=m_nTopLine;
	int n=m_listData.GetCount();
	if(nbottom>=n) nbottom=n-1;
	for(n=ntop;n<=nbottom;n++) DrawLine(n,&dc);
}


void CColList::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	CWnd::OnRButtonDown(nFlags, point);
}

void CColList::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	int nLineOffset=point.y/m_nLineHeight;
	int nNewIndex=m_nTopLine+nLineOffset;
	if(nNewIndex==m_nSelectIndex)	
	{//I𒆂̃ACȅŃ{^_E
		SetCapture();
		m_bOnCapture=TRUE;
		m_nDrawInsertPointerIndex=nNewIndex;
		DrawInsertPointer(TRUE);
	}
	else
	{
		int nCount=m_listData.GetCount();
		if(nNewIndex>=nCount) return;
		SetSel(nNewIndex);
		PostSelChange();
	}
}

void CColList::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	KillTimer(1);
	if(!m_bOnCapture) return;
	::ReleaseCapture();
	m_bOnCapture=FALSE;
	DrawInsertPointer(FALSE);

	if( point.x<0 || point.x>=m_sizeClient.cx||
		point.y<0 || point.y>=m_sizeClient.cy) return;
	int nLineOffset=point.y/m_nLineHeight;
	int nNewIndex=m_nTopLine+nLineOffset;
	if(nNewIndex==m_nSelectIndex) return;//I𒆂̃ACȅŃ{^Abv

	//Ƃ̈ʒũf[^|C^VʒuɃZbg
	POSITION posOld=m_listData.FindIndex(m_nSelectIndex);
	if(!posOld){
		return;
	}
	CColListData* pData=m_listData.GetAt(posOld);
	int nCount=m_listData.GetCount();
	if(nCount<=nNewIndex || nNewIndex<0){
		m_listData.AddTail(pData);
	}else{
		POSITION posNew=m_listData.FindIndex(nNewIndex);
		m_listData.InsertBefore(posNew,pData);
	}

	//Ƃ̃f[^Xg폜
	m_listData.RemoveAt(posOld);

	//IACe̍Đݒ
	if(nNewIndex>m_nSelectIndex) m_nSelectIndex=nNewIndex-1;
	else						 m_nSelectIndex=nNewIndex;

	if(m_nSelectIndex>=nCount)  m_nSelectIndex=nCount-1;
	else if(m_nSelectIndex<0)	m_nSelectIndex=0;

	PostMoveItem();
	Invalidate();
	//CWnd::OnLButtonUp(nFlags, point);
}

//ws擪ɂȂ悤ɃXN[
void CColList::ScrollTo(int nNewPos)
{
	SCROLLINFO si;
	GetScrollInfo(SB_VERT,&si);
	int nCurrentPos=si.nPos;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	si.nPos=m_nTopLine=nNewPos;
	if(nCurrentPos!=nNewPos){
		ScrollWindow(0,(nCurrentPos-nNewPos)*m_nLineHeight);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_VERT,&si);
		UpdateWindow();
	}
}

//wItZbgԂ̃XN[ XN[ TRUE Ԃ
BOOL CColList::ScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_VERT,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	si.nPos=m_nTopLine=nNewPos;
	if(nCurrentPos!=nNewPos){
		ScrollWindow(0,(nCurrentPos-nNewPos)*m_nLineHeight);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_VERT,&si);
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}



void CColList::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	//CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
	int nCurrentPos,nNewPos;
//	int nMin,nMax,nPage;//,nScrollSize;
	SCROLLINFO si;
	GetScrollInfo(SB_VERT,&si);
	nCurrentPos=si.nPos;
//	nMin=si.nMin;
//	nMax=si.nMax;
//	nPage=si.nPage;
//	si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;

	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nNewPos=nPos;
		break;
	case SB_LINEUP:
		nNewPos=nCurrentPos-1;
		break;
	case SB_LINEDOWN:
		nNewPos=nCurrentPos+1;
		break;
	case SB_PAGEUP:
		nNewPos=nCurrentPos-5;
		break;
	case SB_PAGEDOWN:
		nNewPos=nCurrentPos+5;
		break;
	default:
		return;
	}
	ScrollTo(nNewPos);
//	if(nNewPos<0)nNewPos=0;
//	else if(nNewPos>nMax-nPage+1) nNewPos=nMax-nPage+1;
//	si.nPos=m_nTopLine=nNewPos;
//	SetScrollInfo(SB_VERT,&si);
//	if(nCurrentPos!=nNewPos){
//		ScrollWindow(0,(nCurrentPos-nNewPos)*m_nLineHeight);
//	}
}

void CColList::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd::OnSetFocus(pOldWnd);
	DrawLine(m_nSelectIndex);
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
}

int CColList::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	CClientDC dc(this);
	TEXTMETRIC textmetric;
	dc.GetTextMetrics(&textmetric);
	m_nLineHeight=textmetric.tmHeight;

	return 0;
}



void CColList::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_sizeClient.cx=cx;
	m_sizeClient.cy=cy;
	m_nLine=(cy+(m_nLineHeight-1))/m_nLineHeight;
	int nItem=m_listData.GetCount();
	int nPos =GetScrollPos(SB_VERT);
	if(nPos>(nItem-m_nLine))nPos=nItem-m_nLine;
	if(nPos<0) nPos=0;
	//	if(nPos>(nItem-m_nLine))nPos=0;
	SCROLLINFO si;
	si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
	si.nMin=0;
	si.nMax=nItem;
	si.nPage=m_nLine;
	si.nPos =nPos;
	m_nTopLine=nPos;	
	SetScrollInfo(SB_VERT,&si,TRUE);
}

//L[_EbZ[Wnh
void CColList::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	int nCount=m_listData.GetCount();
	if(nCount==0) return;
	int nOldSel=m_nSelectIndex;
	int nNewSel;
	switch(nChar)
	{
	case VK_PRIOR:
		nNewSel=m_nSelectIndex-5;
		break;
	case VK_NEXT:
		nNewSel=m_nSelectIndex+5;
		break;
	case VK_UP:
		nNewSel=m_nSelectIndex-1;
		break;
	case VK_DOWN:
		nNewSel=m_nSelectIndex+1;
		break;
	default:
		return;
	}
	//IACȅ㉺̐ݒ
	if(nNewSel<0)nNewSel=0;
	else if(nNewSel>=nCount)nNewSel=nCount-1;
	if(nOldSel!=nNewSel){
		SetSel(nNewSel);
		//KvȂXN[
		if(nNewSel<m_nTopLine) ScrollTo(nNewSel);
		else if(nNewSel>=m_nTopLine+m_nLine-1) ScrollTo(nNewSel-(m_nLine-2));
	/*	{
			SendMessage(WM_VSCROLL,
						MAKELONG(SB_PAGEUP,0),
						NULL);
		}else if(nNewSel>=m_nTopLine+m_nLine-1){
			SendMessage(WM_VSCROLL,
						MAKELONG(SB_PAGEDOWN,0),
						NULL);
		}
	*/
		PostSelChange();
	}
	//	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

//_CAO̎qEChEƂĎgꍇ͂ĂȂ
//WM_CHAR L[ATABL[̃bZ[W͂Ȃ
BOOL CColList::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message==WM_KEYDOWN && pMsg->hwnd==m_hWnd){
		switch(pMsg->wParam){
		case VK_UP:
		case VK_DOWN:
		case VK_PRIOR:
		case VK_NEXT:
			::TranslateMessage(pMsg);
			::DispatchMessage(pMsg);
			return TRUE;
		}
	}
	return FALSE;	
}

void CColList::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	
	if(nIDEvent==1){
		KillTimer(1);
		CPoint point;
		::GetCursorPos(&point);
		ScreenToClient(&point);
		BOOL bScroll;
		DrawInsertPointer(FALSE);
		if(point.y<m_nLineHeight)						bScroll=ScrollOffset(-1);
		else if(point.y>m_sizeClient.cy-m_nLineHeight)	bScroll=ScrollOffset(1);
		DrawInsertPointer(TRUE);
		if(bScroll)	SendMessage(WM_MOUSEMOVE,0,MAKELONG(point.x,point.y));
		return;
	}
	CWnd::OnTimer(nIDEvent);
}


void CColList::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	HCURSOR hCursor;

	if(m_bOnCapture)
	{
		if( point.x<0 || point.x>=m_sizeClient.cx||
			point.y<0 || point.y>=m_sizeClient.cy)
		{//Lv`ŃNCAgGAOȂ֎~J[\ɂ
			hCursor=AfxGetApp()->LoadStandardCursor(IDC_NO);
			::SetCursor(hCursor);
			return ;
		}
		else
		{
			hCursor=AfxGetApp()->LoadStandardCursor(IDC_SIZENS);
			::SetCursor(hCursor);
		}
		if(point.y<m_nLineHeight || point.y> m_sizeClient.cy-m_nLineHeight)
		{
			m_nIdTimer=SetTimer(1,50,NULL);
			//if(m_nIdTimer) return;
		}
		int nCursorIndex=(point.y/m_nLineHeight)+m_nTopLine;
		int nCount=m_listData.GetCount();
		if(nCursorIndex>nCount)nCursorIndex=nCount;
		if(nCursorIndex!=m_nDrawInsertPointerIndex)
		{
			DrawInsertPointer(FALSE);
			m_nDrawInsertPointerIndex=nCursorIndex;
			DrawInsertPointer(TRUE);
		}
		return ;
	}


	if(m_nSelectIndex>=0)//ǂꂩIԂɂꍇ
	{
		CPoint point;
		::GetCursorPos(&point);
		ScreenToClient(&point);     // client coordinates of mouse position
		int nLineOffset=point.y/m_nLineHeight;
		int nCursorIndex=m_nTopLine+nLineOffset;
		if(nCursorIndex==m_nSelectIndex)	//J[\ʒuIꂽACȅꏊȂ
		{
			hCursor=AfxGetApp()->LoadStandardCursor(IDC_SIZENS);
			::SetCursor(hCursor);
			return;
		}
	}
	hCursor=AfxGetApp()->LoadStandardCursor(IDC_ARROW);
	::SetCursor(hCursor);
	return;
	
//	CWnd::OnMouseMove(nFlags, point);
}



void CColList::OnKillFocus(CWnd* pNewWnd) 
{
	CWnd::OnKillFocus(pNewWnd);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	Invalidate();
	
}


void CColList::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(!m_bOnCapture){
		CWnd* pWnd=GetParent();
		if(pWnd){
			pWnd->PostMessage(WM_CONTEXTMENU,
				(WPARAM)pWnd->m_hWnd,MAKELONG(point.x,point.y));
		}
	}
}
